// $Id: test_i.h,v 1.2 1999/07/09 04:20:08 alex Exp $

// ============================================================================
//
// = LIBRARY
//   TAO/tests/MT_Client
//
// = FILENAME
//   test_i.h
//
// = AUTHOR
//   Carlos O'Ryan
//
// ============================================================================

#ifndef TAO_MT_CLIENT_TEST_I_H
#define TAO_MT_CLIENT_TEST_I_H

#include "testS.h"

class Simple_Server_i : public POA_Simple_Server
{
  // = TITLE
  //   Simpler Server implementation
  //
  // = DESCRIPTION
  //   Implements the Simple_Server interface in test.idl
  //
public:
  Simple_Server_i (CORBA::ORB_ptr orb);
  // ctor

  // = The Simple_Server methods.
  void test_method (CORBA::Environment&)
    ACE_THROW_SPEC ((CORBA::SystemException));

  CORBA::Long get_number (CORBA::Environment&)
    ACE_THROW_SPEC ((CORBA::SystemException));
  
  void put_number (CORBA::Long l,
                   CORBA::Environment &)
    ACE_THROW_SPEC ((CORBA::SystemException));

  CORBA::Long get_put_number (CORBA::Long_out out_l,
                              CORBA::Long in_l,
                              CORBA::Environment &ACE_TRY_ENV)
    ACE_THROW_SPEC ((CORBA::SystemException));

  void shutdown (CORBA::Environment&)
    ACE_THROW_SPEC ((CORBA::SystemException));

private:
  CORBA::ORB_var orb_;

  CORBA::Long number_;
};

#if defined(__ACE_INLINE__)
#include "test_i.i"
#endif /* __ACE_INLINE__ */

#endif /* TAO_MT_CLIENT_TEST_I_H */
